import xmlsec


def _normal_signer(xml, key_spec, cert_spec):
    print(f"Normal signer {key_spec} {cert_spec}")
    return xmlsec.sign(xml, key_spec=key_spec, cert_spec=cert_spec)


def _test_signer(xml, key_spec, cert_spec):
    print(f"Test signer {key_spec} {cert_spec}")
    return xmlsec.sign(xml, key_spec=key_spec, cert_spec=cert_spec)


def _foobar_signer(xml, key_spec, cert_spec):
    print(f"Foobar signer {key_spec} {cert_spec}")
    return xmlsec.sign(xml, key_spec=key_spec, cert_spec=cert_spec)


def _hsm_signer(xml, key_spec, cert_spec):
    print(f"HSM signer {key_spec} {cert_spec}")
    return xmlsec.sign(xml, key_spec=key_spec, cert_spec=cert_spec)


_signers = {
    'normal_signer': _normal_signer,
    'test_signer': _test_signer,
    'foobar_signer': _foobar_signer,
    'hsm_signer': _hsm_signer
}


class Signers():
    def __init__(self, signer):
        self.type = signer['type']
        self.key_spec = signer['key_spec']
        self.cert_spec = signer.get('cert_spec', None)

    def sign(self, xml):
        return _signers[self.type](xml, self.key_spec, self.cert_spec)
